/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.cezar.cezargis.ws.zbdbdot.client;

import com.cezar.cezargis.ws.zbdbdot.Import;
import com.cezar.cezargis.ws.zbdbdot.ImportStatus;
import com.cezar.cezargis.ws.zbdbdot.ZbdBdotWebServiceException;
import com.cezar.cezargis.ws.zbdbdot.common.CommonFunction;
import com.cezar.cezargis.ws.zbdbdot.schema.PobierzRozmiarPlikuFault;
import com.cezar.cezargis.ws.zbdbdot.schema.PobierzRozmiarPlikuResponse;
import com.cezar.cezargis.ws.zbdbdot.schema.PotwierdzRozmiarPliku;
import com.cezar.cezargis.ws.zbdbdot.schema.PotwierdzRozmiarPlikuFault;
import com.cezar.cezargis.ws.zbdbdot.schema.PotwierdzRozmiarPlikuResponse;
import com.cezar.cezargis.ws.zbdbdot.schema.PrzygotujPlikFault;
import com.cezar.cezargis.ws.zbdbdot.schema.PrzygotujPlikResponse;
import com.cezar.cezargis.ws.zbdbdot.schema.StatusPrzygotowaniaType;
import com.cezar.cezargis.ws.zbdbdot.schema.WyslijPlikDumpaFault;
import com.cezar.cezargis.ws.zbdbdot.schema.WyslijPlikDumpaResponse;
import com.cezar.cezargis.ws.zbdbdot.schema.ZbdBdotService;
import com.cezar.cezargis.ws.zbdbdot.schema.ZbdBdotServicePorts;
import com.cezar.cezargis.ws.zbdbdot.service.DbImportService;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.xml.namespace.QName;

public class ZbdbdotClient {

    private String endPoint;
    private StatusPrzygotowaniaType statusPrzygotowania;
    private String fileName = DbImportService.FILE_DUMP;

    public ZbdbdotClient(String endPoint) {
	this.endPoint = endPoint;
    }

    private ZbdBdotService getProxy() throws MalformedURLException {
	ZbdBdotServicePorts proxyFactory = new ZbdBdotServicePorts(
		new URL("http://127.0.0.1:8080/cezargis-ws-zbdbdot-service/ws/zbdbdot?wsdl"),
		new QName("http://ws.cezargis.cezar.com/zbdbdot/1.0", "ZbdBdotServicePorts"));
	return proxyFactory.getZbdBdotService();
    }

    /**
     * Metoda 0 wywołanie wszysytkich metod
     */
    public void przygotujPlikProces() throws Exception {
	przygotujPlik();
	pobierzRozmiarPliku();
	pobierzPliku();
	potwierdzRozmiarPliku();
    }

    public StatusPrzygotowaniaType pobierzStatus() {
	return statusPrzygotowania;
    }

    /**
     * Metoda 1 przygotowanie pliku
     * @throws PrzygotujPlikFault
     * @throws MalformedURLException 
     */
    public void przygotujPlik() throws Exception {
	ZbdBdotService proxy = getProxy();
	PrzygotujPlikResponse przygotujPlik = proxy.przygotujPlik(null);
	statusPrzygotowania = przygotujPlik.getStatusPrzygotowania();
    }

    /**
     * Metoda 2: pobierzRozmiarPliku;
     * @throws InterruptedException 
     */
    public void pobierzRozmiarPliku() throws Exception {
	ZbdBdotService proxy = getProxy();
	try {
	    boolean getStaus = false;
	    while (!getStaus) {
		PobierzRozmiarPlikuResponse pobierzRozmiarPliku = proxy.pobierzRozmiarPliku(null);
		statusPrzygotowania = pobierzRozmiarPliku.getStatusPrzygotowania();
		System.out.println("Rozmiar: " + pobierzRozmiarPliku.getRozmiarPliku());
		System.out.println("Status: " + statusPrzygotowania.name());
		if (pobierzRozmiarPliku.getStatusPrzygotowania() == StatusPrzygotowaniaType.PLIK_OK) {
		    getStaus = true;
		} else {
		    Thread.sleep(5000);
		}
	    }
	} catch (PobierzRozmiarPlikuFault ex) {
	    ex.printStackTrace();
	    statusPrzygotowania = ex.getFaultInfo().getStatusPrzygotowania();
	    System.out.println("Status pobierzRozmiarPliku:" + statusPrzygotowania.name());
	} finally {
	    //zapis do logów
	    System.out.println("Status przygotujPlik:" + statusPrzygotowania.name());
	    saveLog("METODA 2 pobierzRozmiarPliku", statusPrzygotowania.name());
	}
    }

    private void saveLog(String funName, String statusName) {
	try {
	    DbImportService.setToLog(funName, statusName);
	} catch (ZbdBdotWebServiceException ex) {
	    Logger.getLogger(ZbdbdotClient.class.getName()).log(Level.SEVERE, null, ex);
	}
    }

    /**
     * Metoda 3: pobierzPliku
     * @throws PotwierdzRozmiarPlikuFault 
     */
    public void pobierzPliku() throws Exception {
	System.out.println("METODA 3 pobierzPliku");
	ZbdBdotService proxy = getProxy();
	InputStream inputStream = null;
	try {
	    System.out.println("Plik: poczatek pobierania");
	    WyslijPlikDumpaResponse wyslijPlikDumpa = proxy.wyslijPlikDumpa(null);

	    statusPrzygotowania = wyslijPlikDumpa.getStatusPrzygotowania();

	    //pobranie strumienia pliku
	    inputStream = wyslijPlikDumpa.getLargeAmountOfData().getInputStream();
	    System.out.println("Plik: pobierany inputStream");

	    //zapisanie pliku w odpowiedniej lokalizacji
	    OutputStream out = new FileOutputStream(new File(fileName));
	    int read = 0;
	    byte[] buf = new byte[1024];
	    while ((read = inputStream.read(buf)) != -1) {
		out.write(buf, 0, read);
	    }
	    inputStream.close();
	    out.flush();
	    out.close();
	    System.out.println("Plik zapisany");
	} catch (IOException ex) {
	    Logger.getLogger(ZbdbdotClient.class.getName()).log(Level.SEVERE, null, ex);
	    saveLog("METODA 3 pobierzPliku", ImportStatus.IMPORT_PLIK_ZAPIS_ERROR.name());
	    statusPrzygotowania = StatusPrzygotowaniaType.PLIK_ERROR;
	} catch (WyslijPlikDumpaFault ex) {
	    ex.printStackTrace();
	    statusPrzygotowania = ex.getFaultInfo().getStatusPrzygotowania();
	    System.out.println("Status pobierzPliku:" + statusPrzygotowania.name());
	} finally {
	    try {
		inputStream.close();
		//zapis do logów
		saveLog("METODA 3 pobierzPliku", statusPrzygotowania.name());
	    } catch (IOException ex) {
		Logger.getLogger(ZbdbdotClient.class.getName()).log(Level.SEVERE, null, ex);
	    }
	}
    }

    /**
     * Metoda 4: potwierdzRozmiarPliku
     */
    public void potwierdzRozmiarPliku() throws Exception {
	String metodaName = "METODA 4 potwierdzRozmiarPliku";
	ZbdBdotService proxy = getProxy();
	System.out.println(metodaName);
	try {
	    File file = new File(fileName);

	    if (file.exists() || file.isFile()) {
		statusPrzygotowania = StatusPrzygotowaniaType.POTWIERDZENIE_ODBIORU;
		//status = ImportStatus.IMPORT_PLIK_OK.name();
		System.out.println(statusPrzygotowania.name());
		saveLog(metodaName, statusPrzygotowania.name());
		PotwierdzRozmiarPliku prp = new PotwierdzRozmiarPliku();
		prp.setRozmiarPliku(file.length());
		prp.setSumaKontrolna(CommonFunction.getChecksumMD5(fileName));
		PotwierdzRozmiarPlikuResponse prpr = proxy.potwierdzRozmiarPliku(prp);
		statusPrzygotowania = prpr.getStatusPrzygotowania();
		System.out.println(statusPrzygotowania.name());
		saveLog(metodaName, statusPrzygotowania.name());
		//poprawne pobranie pliku pg_restore
		if (statusPrzygotowania == StatusPrzygotowaniaType.PLIK_POPRAWNY) {
		    try {
			//kasowanie schematu
			DbImportService.dropSchemeDeadLockCheck();
			statusPrzygotowania = StatusPrzygotowaniaType.KASOWANIE_STAREGO_SCHEMATU;
			saveLog(metodaName, statusPrzygotowania.name());
			//Wywołanie metody  pg_restore
			Import.restoreSchema();
			statusPrzygotowania = StatusPrzygotowaniaType.PRZYWROCENIE_NOWEGO_SCHEMATU;
			saveLog(metodaName, statusPrzygotowania.name());
			//Wywołanie procedury kopiującej
			DbImportService.copyToBdotSchema();
			statusPrzygotowania = StatusPrzygotowaniaType.PRZEKOPIOWANE_DO_STRUKTURY_BDOT;
			saveLog(metodaName, statusPrzygotowania.name());
		    } catch (ZbdBdotWebServiceException ex) {
			ex.printStackTrace();
			statusPrzygotowania = StatusPrzygotowaniaType.BLAD;
			Logger.getLogger(ZbdbdotClient.class.getName()).log(Level.SEVERE, null, ex);
		    } finally {
			System.out.println(statusPrzygotowania.name());
			saveLog(metodaName, statusPrzygotowania.name());
		    }
		}
	    } else {
		statusPrzygotowania = StatusPrzygotowaniaType.BLAD_POTWIERDZENIE_ODBIORU;
		System.out.println(statusPrzygotowania.name());
	    }
	} catch (PotwierdzRozmiarPlikuFault ex) {
	    statusPrzygotowania = ex.getFaultInfo().getStatusPrzygotowania();
	    ex.printStackTrace();
	    System.out.println("Status potwierdzRozmiarPliku:" + statusPrzygotowania.name());
	    //zapis do logów
	    saveLog(metodaName, statusPrzygotowania.name());
	}
    }
}
