/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.cezar.cezargis.ws.zbdbdot.service;

import com.cezar.cezargis.ws.zbdbdot.DbStatus;
import com.cezar.cezargis.ws.zbdbdot.ZbdBdotWebServiceException;
import com.cezar.cezargis.ws.zbdbdot.common.CommonFunction;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.Timestamp;
import java.util.Date;

/**
 *
 * @author mkanik
 */
public class DbImportService {

    /*RESTORE*/
    public static String PG_RESTORE = getProperty("PG_RESTORE");
    public static String DB_HOST = getProperty("DB_HOST");
    public static String DB_PORT = getProperty("DB_PORT");
    public static String BD_BASE = getProperty("BD_BASE");
    public static String DB_SCHEMA = getProperty("DB_SCHEMA");
    public static String DB_USER = getProperty("DB_USER");
    public static String DB_PASS = getProperty("DB_PASS");
    public static String DB_SCHEMA_DUMP = getProperty("DB_SCHEMA_DUMP");
    public static String FILE_DUMP = getProperty("FILE_DUMP");
    public static String FILE_PROCES = getProperty("FILE_PROCES");

    private static Connection getConnection() throws Exception {
	Class.forName("org.postgresql.Driver");
	// DB_URL = jdbc:postgresql://localhost:5432/cezargis
	String db_url = "jdbc:postgresql://" + DB_HOST + ":" + DB_PORT + "/"
		+ BD_BASE;
	Connection c = DriverManager.getConnection(db_url, DB_USER, DB_PASS);
	c.setAutoCommit(false);
	return c;
    }

    public static void dropSchemeDeadLockCheck() throws ZbdBdotWebServiceException, InterruptedException {
	//org.postgresql.util.PSQLException: ERROR: deadlock detected
	int deadlock = 0;
	try {
	    System.out.println("Przed drop");
	    dropScheme();
	    System.out.println("Po drop");
	} catch (ZbdBdotWebServiceException e) {
	    String expMsg = e.getMessage();
	    if (deadlock < 5 && expMsg.contains("ERROR: deadlock detected")) {
		System.out.println("deadlock sleep = " + deadlock);
		deadlock++;
		Thread.sleep(60000);
		dropScheme();
	    } else {
		ZbdBdotWebServiceException zbdBdotWebServiceException = new ZbdBdotWebServiceException(e);
		zbdBdotWebServiceException.setDbStatus(DbStatus.BLAD);
		throw zbdBdotWebServiceException;
	    }
	}
    }

    public static void dropScheme() throws ZbdBdotWebServiceException {
	String sql = "DROP SCHEMA IF EXISTS " + DB_SCHEMA_DUMP + " CASCADE;";
	Connection conn = null;
	PreparedStatement ps = null;
	try {
	    conn = getConnection();
	    ps = conn.prepareStatement(sql);
	    ps.execute();
	    conn.commit();
	} catch (Exception e) {
	    e.printStackTrace();
	    try {
		conn.rollback();
	    } catch (Exception ignored) {
	    }
	    ZbdBdotWebServiceException zbdBdotWebServiceException = new ZbdBdotWebServiceException(e);
	    zbdBdotWebServiceException.setDbStatus(DbStatus.BLAD);
	    throw zbdBdotWebServiceException;
	} finally {
	    try {
		ps.close();
		conn.close();
	    } catch (Exception ignored) {
	    }
	}
    }

    public static void copyToBdotSchema() throws ZbdBdotWebServiceException {

	String sql = "SELECT " + DB_SCHEMA + ".buf_kopiujdanezzbdbdot1();";
	Connection conn = null;
	PreparedStatement ps = null;
	try {
	    conn = getConnection();
	    ps = conn.prepareStatement(sql);
	    ps.execute();
	    conn.commit();
	} catch (Exception e) {
	    e.printStackTrace();
	    try {
		conn.rollback();
	    } catch (Exception ignored) {
	    }
	    ZbdBdotWebServiceException zbdBdotWebServiceException = new ZbdBdotWebServiceException(DbStatus.BLAD);
	    zbdBdotWebServiceException.setException(e);
	    throw zbdBdotWebServiceException;
	} finally {
	    try {
		ps.close();
		conn.close();
	    } catch (Exception ignored) {
	    }
	}
    }

    /*-------------------------------------------------------------------------*/
    /*				LOGOWANIE				       */
    /*-------------------------------------------------------------------------*/
    public static void setToLog(String funName, String statusName) throws ZbdBdotWebServiceException {
	Date date = new Date();
	java.sql.Date sqlDate = new java.sql.Date(date.getTime());
	String sql = "INSERT INTO "
		+ DB_SCHEMA
		+ ".zbd_bdot_client_log (zbdcl_data, zbdcl_funkcja, zbdcl_status) VALUES (?,?,?);";

	Connection conn = null;
	PreparedStatement ps = null;
	try {
	    //getCurrentJavaSqlTimestamp()
	    conn = getConnection();
	    ps = conn.prepareStatement(sql);
	    ps.setDate(1, sqlDate);
	    //ps.setTimestamp(1, getCurrentSqlTimestamp());
	    ps.setString(2, funName);
	    ps.setString(3, statusName);
	    ps.executeUpdate();
	    conn.commit();
	} catch (Exception e) {
	    try {
		conn.rollback();
	    } catch (Exception ignored) {
	    }
	    throw new ZbdBdotWebServiceException(e);
	} finally {
	    try {
		ps.close();
		conn.close();
	    } catch (Exception ignored) {
	    }
	}
    }

    public static Timestamp getCurrentSqlTimestamp() {
	Date date = new Date();
	return new Timestamp(date.getTime());
    }

    private static String getProperty(String property) {
	try {
	    return CommonFunction.getProperty(DbImportService.class, property);
	} catch (Exception e) {
	    e.printStackTrace();
	    return "";
	}
    }
}
