/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.cezar.cezargis.ws.zbdbdot.client;

import com.cezar.cezargis.ws.zbdbdot.DbStatus;
import com.cezar.cezargis.ws.zbdbdot.Import;
import com.cezar.cezargis.ws.zbdbdot.ImportStatus;
import com.cezar.cezargis.ws.zbdbdot.ZbdBdotWebServiceException;
import com.cezar.cezargis.ws.zbdbdot.schema.PobierzRozmiarPlikuFault;
import com.cezar.cezargis.ws.zbdbdot.schema.PobierzRozmiarPlikuResponse;
import com.cezar.cezargis.ws.zbdbdot.schema.PotwierdzRozmiarPliku;
import com.cezar.cezargis.ws.zbdbdot.schema.PotwierdzRozmiarPlikuFault;
import com.cezar.cezargis.ws.zbdbdot.schema.PotwierdzRozmiarPlikuResponse;
import com.cezar.cezargis.ws.zbdbdot.schema.PrzygotujPlikFault;
import com.cezar.cezargis.ws.zbdbdot.schema.PrzygotujPlikResponse;
import com.cezar.cezargis.ws.zbdbdot.schema.StatusPrzygotowaniaType;
import com.cezar.cezargis.ws.zbdbdot.schema.WyslijPlikDumpaFault;
import com.cezar.cezargis.ws.zbdbdot.schema.WyslijPlikDumpaResponse;
import com.cezar.cezargis.ws.zbdbdot.schema.ZbdBdotService;
import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.xml.namespace.QName;
import java.net.URL;
import com.cezar.cezargis.ws.zbdbdot.schema.ZbdBdotServicePorts;
import com.cezar.cezargis.ws.zbdbdot.service.DbImportService;
import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import org.junit.Ignore;
import org.postgresql.util.Base64;

/**
 *
 * @author mkanik
 */
public class ZbdBdotJUnitTest {

    ZbdBdotService ssproxy;
    String fileName;

    public ZbdBdotJUnitTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() throws MalformedURLException {
	ZbdBdotServicePorts proxyFactory = new ZbdBdotServicePorts(
		new URL("http://127.0.0.1:8080/cezargis-ws-zbdbdot-service/ws/zbdbdot?wsdl"),
		new QName("http://ws.cezargis.cezar.com/zbdbdot/1.0", "ZbdBdotServicePorts"));
	ssproxy = proxyFactory.getZbdBdotService();
	fileName = "k:\\dump\\out_dump.backup";
    }

    @After
    public void tearDown() {
    }
    // TODO add test methods here.
    // The methods must be annotated with annotation @Test. For example:
    //

    @Test
    public void przygotujPlik() throws MalformedURLException {
	System.out.println("METODA 1 przygotujPlik");
	String status = "";
	try {
	    PrzygotujPlikResponse przygotujPlik = ssproxy.przygotujPlik(null);
	    status = przygotujPlik.getStatusPrzygotowania().name();
	} catch (PrzygotujPlikFault ex) {
	    status = ex.getFaultInfo().getStatusPrzygotowania().name();
	    ex.printStackTrace();
	} finally {
	    //zapis do logów
	    System.out.println("Status przygotujPlik:" + status);
	    saveLog("METODA 1 przygotujPlik", status);
	}
    }

    @Test
    public void pobierzRozmiarPliku() throws InterruptedException {
	System.out.println("METODA 2 pobierzRozmiarPliku");
	String status = "";
	try {
	    boolean getStaus = false;
	    while (!getStaus) {
		PobierzRozmiarPlikuResponse pobierzRozmiarPliku = ssproxy.pobierzRozmiarPliku(null);
		status = pobierzRozmiarPliku.getStatusPrzygotowania().name();
		System.out.println("Rozmiar: " + pobierzRozmiarPliku.getRozmiarPliku());
		System.out.println("Status: " + status);
		if (pobierzRozmiarPliku.getStatusPrzygotowania() == StatusPrzygotowaniaType.PLIK_OK) {
		    getStaus = true;
		} else {
		    Thread.sleep(5000);
		}
	    }
	} catch (PobierzRozmiarPlikuFault ex) {
	    ex.printStackTrace();
	    status = ex.getFaultInfo().getStatusPrzygotowania().name();
	    System.out.println("Status pobierzRozmiarPliku:" + status);
	} finally {
	    //zapis do logów
	    System.out.println("Status przygotujPlik:" + status);
	    saveLog("METODA 2 pobierzRozmiarPliku", status);
	}
    }
    /*
     * Metoda 3 pobranie pliku
     */

    @Test
    public void pobierzPliku() throws PotwierdzRozmiarPlikuFault {
	System.out.println("METODA 3 pobierzPliku");
	String status = "";
	InputStream inputStream = null;
	try {
	    System.out.println("Plik: poczatek pobierania");
	    WyslijPlikDumpaResponse wyslijPlikDumpa = ssproxy.wyslijPlikDumpa(null);

	    status = wyslijPlikDumpa.getStatusPrzygotowania().name();

	    //pobranie strumienia pliku
	    inputStream = wyslijPlikDumpa.getLargeAmountOfData().getInputStream();
	    System.out.println("Plik: pobierany inputStream");

	    //zapisanie pliku w odpowiedniej lokalizacji
	    OutputStream out = new FileOutputStream(new File(fileName));
	    int read = 0;
	    byte[] buf = new byte[1024];
	    while ((read = inputStream.read(buf)) != -1) {
		out.write(buf, 0, read);
	    }
	    inputStream.close();
	    out.flush();
	    out.close();
	    System.out.println("Plik zapisany");
	} catch (IOException ex) {
	    Logger.getLogger(ZbdBdotJUnitTest.class.getName()).log(Level.SEVERE, null, ex);
	    saveLog("METODA 3 pobierzPliku", ImportStatus.IMPORT_PLIK_ZAPIS_ERROR.name());
	} catch (WyslijPlikDumpaFault ex) {
	    ex.printStackTrace();
	    status = ex.getFaultInfo().getStatusPrzygotowania().name();
	    System.out.println("Status pobierzPliku:" + status);
	} finally {
	    try {
		inputStream.close();
		 //zapis do logów
		saveLog("METODA 3 pobierzPliku", status);
	    } catch (IOException ex) {
		Logger.getLogger(ZbdBdotJUnitTest.class.getName()).log(Level.SEVERE, null, ex);
	    }
	}
    }

    /*
     * Metoda 4 pobranie pliku
     */
    @Test
    public void potwierdzRozmiarPliku() throws InterruptedException {
	String metodaName = "METODA 4 potwierdzRozmiarPliku";
	System.out.println(metodaName);
	String status = "";
	try {
	    File file = new File(fileName);

	    if (file.exists() || file.isFile()) {
		status = ImportStatus.IMPORT_PLIK_OK.name();
		System.out.println(status);
		saveLog(metodaName, status);
		PotwierdzRozmiarPliku prp = new PotwierdzRozmiarPliku();
		prp.setRozmiarPliku(file.length());
		prp.setSumaKontrolna(getChecksumMD5(fileName));
		PotwierdzRozmiarPlikuResponse prpr = ssproxy.potwierdzRozmiarPliku(prp);
		status = prpr.getStatusPrzygotowania().name();
		System.out.println(status);
		saveLog(metodaName, status);
		//poprawne pobranie pliku pg_restore
		if (prpr.getStatusPrzygotowania() == StatusPrzygotowaniaType.PLIK_POPRAWNY) {		    
		    try {
			//kasowanie schematu
			DbImportService.dropSchemeDeadLockCheck();
			status = DbStatus.OK.name();
			//Wywołanie metody  pg_restore
			Import.restoreSchema();
		    } catch (ZbdBdotWebServiceException ex) {	
			status = ex.getDbStatus().name();
			Logger.getLogger(ZbdBdotJUnitTest.class.getName()).log(Level.SEVERE, null, ex);
		    } finally {
			System.out.println(status);
			saveLog(metodaName, status);
		    }
		}
	    } else {
		status = ImportStatus.IMPORT_PLIK_ERROR.name();
		System.out.println(status);
	    }
	} catch (PotwierdzRozmiarPlikuFault ex) {
	    status = ex.getFaultInfo().getStatusPrzygotowania().name();
	    ex.printStackTrace();	    
	    System.out.println("Status potwierdzRozmiarPliku:" + status);
	    //zapis do logów
	    saveLog(metodaName, status);
	}
    }

    @Ignore
    private void saveLog(String funName, String statusName) {
	try {
	    DbImportService.setToLog(funName, statusName);
	} catch (ZbdBdotWebServiceException ex) {
	    Logger.getLogger(ZbdBdotJUnitTest.class.getName()).log(Level.SEVERE, null, ex);
	}
    }

    @Ignore
    private static String getChecksumMD5(String fileName) {
	try {
	    int theByte = 0;
	    MessageDigest md = MessageDigest.getInstance("MD5");
	    BufferedInputStream bis = new BufferedInputStream(
		    new FileInputStream(fileName));

	    while ((theByte = bis.read()) != -1) {
		md.update((byte) theByte);
	    }
	    bis.close();
	    byte[] digest = md.digest();
	    String encodeBytes = Base64.encodeBytes(digest);

	    return encodeBytes;
	} catch (NoSuchAlgorithmException e) {
	    e.printStackTrace();
	} catch (FileNotFoundException e) {
	    e.printStackTrace();
	} catch (IOException e) {
	    e.printStackTrace();
	}
	return null;
    }
}
